package ru.ulstu.indicator.repository;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import ru.ulstu.indicator.model.Course;
import ru.ulstu.indicator.model.Indicator;

import java.util.List;

public interface IndicatorRepository extends JpaRepository<Indicator, Integer> {
    Indicator findByName(String name);

    @Query("select i from Indicator i WHERE :course member of i.courses")
    List<Indicator> findAllByCourse(@Param("course") Course course);
}
