package ru.ulstu.report.controller;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import ru.ulstu.report.model.ReportPeriod;
import ru.ulstu.report.service.ReportPeriodService;

@Controller
@RequestMapping("admin")
public class ReportPeriodController {
    private final ReportPeriodService reportPeriodService;

    public ReportPeriodController(ReportPeriodService reportPeriodService) {
        this.reportPeriodService = reportPeriodService;
    }

    @GetMapping("reportPeriodList")
    public String getReportPeriods(Model model) {
        model.addAttribute("reportPeriods", reportPeriodService.getReportPeriods());
        return "admin/reportPeriodList";
    }

    @GetMapping("editReportPeriod/{reportPeriodId}")
    public String getReportPeriods(@PathVariable(value = "reportPeriodId") Integer reportPeriodId, Model model) {
        model.addAttribute("reportPeriod",
                reportPeriodId == 0
                        ? new ReportPeriod()
                        : reportPeriodService.getById(reportPeriodId));
        return "admin/editReportPeriod";
    }

    @PostMapping(value = "saveReportPeriod", params = "save")
    public String saveReportPeriods(ReportPeriod reportPeriod) {
        reportPeriodService.save(reportPeriod);
        return "redirect:/admin/reportPeriodList";
    }

    @PostMapping(value = "saveReportPeriod", params = "delete")
    public String delete(ReportPeriod reportPeriod) {
        reportPeriodService.delete(reportPeriod);
        return "redirect:/admin/reportPeriodList";
    }
}
