package ru.ulstu.report.repository;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import ru.ulstu.aspirant.model.Aspirant;
import ru.ulstu.report.model.Report;
import ru.ulstu.report.model.ReportPeriod;
import ru.ulstu.statistic.model.RatingItem;

import java.util.List;

public interface ReportRepository extends JpaRepository<Report, Integer> {

    List<Report> findAllByReportPeriod(ReportPeriod reportPeriod);

    Report findByReportPeriodAndAspirant(ReportPeriod reportPeriod, Aspirant aspirant);

    @Query("SELECT new ru.ulstu.statistic.model.RatingItem(r.aspirant, (SELECT cast(sum(rv.indicatorValue) AS Integer)  FROM ReportValue rv WHERE rv MEMBER OF r.values)) FROM Report r JOIN r.reportPeriod rp WHERE rp.id = :reportPeriodId")
    List<RatingItem> getRating(@Param("reportPeriodId") Integer reportPeriodId);
}
